<?php
/**
 * Neo HTML Protector neohp_htmlprotect
 */

$neohp_htmlprotect=new neohp_htmlprotect();
class neohp_htmlprotect {
	public function __construct() {
		// DxŃ_CNgǉitemplate_redirecttbNgpj
		if(get_option('neohp_htmlprotect', '0') == 1) {
			add_action('template_redirect', array($this, 'neohp_check_and_redirect'), 2);
		}
	}
	
	// 9b̃NbL[𔭍săGR[hꂽURLۑ
	public function neohp_set_cookie_and_redirect() {
		// ݂URL擾
		$current_url = $_SERVER['REQUEST_URI'];

		// URLBase64GR[h
		$neo_encoded_url = base64_encode($current_url);

		// title擾
		$title = wp_title('|', false, 'right') . get_bloginfo('name');

		// 擾
		$lang = get_bloginfo('language');

		// URL擾
		$scheme = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https' : 'http';
		$host = $_SERVER['HTTP_HOST'];
		$request_uri = $_SERVER['REQUEST_URI'];
		$current_url = $scheme . '://' . $host . $request_uri;

		// UNIXtime / 60
		$min = floor(time() / 60);

		// NbL[𐶐
		$cookie_name = 'ne' . $min;

		// JavaScriptŃGR[hꂽURLfR[hă_CNgXNvg}
		$html = '';
		// <!doctype html>̑OɌxbZ[W\
		if(get_option('neohp_htmlprotect_message', NEOHP_VIEWSOURCE_DEFAULT ) !== '') {
			$protectmsg=esc_html(get_option('neohp_htmlprotect_message', NEOHP_VIEWSOURCE_DEFAULT ) );

			// [U[IPAhX擾
			$user_ip = $_SERVER['REMOTE_ADDR'];

			$protectmsg = str_replace('$IP', $user_ip, $protectmsg);
			$protectmsg = str_replace('$URL', $current_url, $protectmsg);
			$protectmsg = str_replace('$KEY', "view-source:$current_url", $protectmsg);
			$protectmsg = str_replace('\\n', "\n", $protectmsg);

			$html .= "<!--\n\n" . $protectmsg . "\n\n-->";
		}
		$html .= '<!doctype html><html lang="' . $lang . '"><head><meta charset="UTF-8">';
		$html .= '<script>';
		$html .= 'var neUrl="' . $neo_encoded_url . '";';
		$html .= 'document.cookie="' . $cookie_name . '="+neUrl+";max-age=9;path=/";';
		$html .= 'location.href=atob(neUrl);';
		$html .= '</script>';
		$html .= '<title>' . $title . '</title>';

		$meta_description = get_post_meta(get_the_ID(), 'meta_description', true);
		$meta_keywords = get_post_meta(get_the_ID(), 'meta_keywords', true);
		if($meta_description !== "") {
			$html .= '<meta name="description" content="' . $meta_description . '">';
		}
		if($meta_keywords !== "") {
			$html .= '<meta name="keywords" content="' . $meta_keywords . '">';
		}
		$image_url = get_the_post_thumbnail_url(get_the_ID(), 'full');
		if($image_url) {
			$html .= '<meta property="og:image" content="' . $image_url . '">';
		}

		$html .= '<meta property="og:type" content="website">';
		$html .= '<meta property="og:description" content="' . get_bloginfo('description') . '">';
		$html .= '<meta property="og:title" content="' . $title . '">';
		$html .= '<meta property="og:url" content="' . $current_url . '">';
		$html .= '<meta property="og:site_name" content="' . get_bloginfo('name') . '">';

		$feedbase = $scheme . '://' . $host;
		$html .= '<link rel="alternate" type="application/rss+xml" title="' . get_bloginfo('name') . ' &raquo; feed" href="' . $feedbase . '/feed/">';
		$html .= '<link rel="alternate" type="application/rss+xml" title="' . get_bloginfo('name') . ' &raquo; comment feed" href="' . $feedbase . '/comments/feed/">';

		$html .= '</head></html>';

		echo $html;
		exit;
	}

	// NbL[GR[hꂽURL擾A_CNg
	public function neohp_redirect_from_cookie() {
		// UNIXtime / 60
		$min = floor(time() / 60);
		$cookie_name = 'ne' . $min;

		$min2 = floor(time() / 60);
		$cookie_name2 = 'ne' . $min2;

		if (isset($_COOKIE[$cookie_name])) {
			// NbL[ɃGR[hꂽURLꍇAfR[hă_CNg
			$neo_encoded_url = $_COOKIE[$cookie_name];
			$decoded_url = base64_decode($neo_encoded_url);

			// NbL[폜
			setcookie($cookie_name, "", time() - 3600, "/");

			// ݂̃y[Wƃ_CNg悪قȂꍇɃ_CNg
			if ($_SERVER['REQUEST_URI'] !== $decoded_url) {
				header("Location: $decoded_url");
				exit;
			}
		}

		// 1O
		if (isset($_COOKIE[$cookie_name2])) {
			// NbL[ɃGR[hꂽURLꍇAfR[hă_CNg
			$neo_encoded_url = $_COOKIE[$cookie_name2];
			$decoded_url = base64_decode($neo_encoded_url);

			// NbL[폜
			setcookie($cookie_name2, "", time() - 3600, "/");

			// ݂̃y[Wƃ_CNg悪قȂꍇɃ_CNg
			if ($_SERVER['REQUEST_URI'] !== $decoded_url) {
				header("Location: $decoded_url");
				exit;
			}
		}
	}

	// NbL[邩mFă_CNg
	public function neohp_check_and_redirect() {
		if ( ! is_user_logged_in() ) {
			// RSSłȂƁAARg̎łȂ
			if (
				strpos($_SERVER['REQUEST_URI'], '/feed/') === false
			 &&	empty($_GET['unapproved'])  // RgeiF҂j
			 &&	empty($_GET['moderation-hash']) // RgeiFpnbVj
			) {
				// UNIXtime / 60
				$min = floor(time() / 60);
				$cookie_name = 'ne' . $min;

				$min2 = floor(time() / 60) - 1;
				$cookie_name2 = 'ne' . $min2;

				// NbL[ZbgĂꍇA_CNgs
				if (isset($_COOKIE[$cookie_name])) {
					$this->neohp_redirect_from_cookie();
				} elseif (isset($_COOKIE[$cookie_name2])) {
					$this->neohp_redirect_from_cookie();
				} else {
					// NbL[ȂꍇA9b̃NbL[𔭍să_CNg
					$this->neohp_set_cookie_and_redirect();
				}
			}
		}
	}
}
